#pragma once

#include <glm/gtc/type_ptr.hpp>

/**
like Volume but stores 3 values at one positions
*/
class VectorField
{
public:
	VectorField(int w, int h, int d);
	~VectorField();

	glm::vec3 get(int x, int y, int z);
	glm::vec3 get(const glm::ivec3& p);
	glm::vec3 get(int i);

	/**
	takes any position inside the volume and tri-linear interpolates its position
	*/
	glm::vec3 interpolate(const glm::vec3& p);
	bool set(glm::vec3 v, int x, int y, int z);
	bool set(glm::vec3 v, int i);

	int size();
private:
	glm::vec3* vectors;

	int _size;
	int sizeX;
	int sizeY;
	int sizeZ;
};

